//***************************************************************************
//
// Advanced CodeColony Camera
// Philipp Crocoll, 2003
//
//***************************************************************************


#include <GLUT/glut.h>		// Need to include it here because the GL* types are required
#define PI 3.1415926535897932384626433832795
#define PIdiv180 (PI/180.0)

/////////////////////////////////
//Note: All angles in degrees  //
/////////////////////////////////

typedef struct  //Float 3d-vect, normally used
{
	GLfloat x,y,z;
}_3DVector;

typedef struct
{
	GLfloat x,y;
}_2DVector;

typedef struct
{
	_3DVector ViewDir;
	_3DVector RightVector;	
	_3DVector UpVector;
	_3DVector Position;
	GLfloat RotatedX, RotatedY, RotatedZ;	
} Camera;
	
void Move (Camera* camera, _3DVector Direction );
void RotateX (Camera* camera, GLfloat Angle );
void RotateY (Camera* camera, GLfloat Angle );
void RotateZ (Camera* camera, GLfloat Angle );

void MoveForward (Camera* camera, GLfloat Distance );
void MoveUpward (Camera* camera, GLfloat Distance );
void StrafeRight (Camera* camera, GLfloat Distance );
